/*
 * File:   main.c
 * Author: F.Giamarchi
 *
 * Created on 3 janvier 2017, 00:00
 */

#include <xc.h>         // XC8 compilateur
#include <stdint.h>     // uint8_t dfinitions
#include <stdio.h>
#include <stdlib.h>

#include "system.h"     // fichier des actions d'initialisation du C
#include "interruptions.h"
#include "neopixel.h"

uint8_t etat;     // exemple de dclaration d'une variable 8 bits non signe
uint16_t compteur;   // exemple de dclaration d'une variable 16 bits non signe
char command[6];

void main(void)
{
/*  On initialise le microcontroleur */
    Init_System();
    Init_Timer0();
    Init_UART();
    Init_Interruptions();
    
/*  Test UART */
    printf("\r\nPIC 16F1847\r\n");
    printf("Test NeoPixel\r\n");

    compteur = 0;
    
/*  Cration d'une boucle infinie indispensable !!! */
    while (1)
    {
        Synchronisation();      // force la boucle infinie  s'xcuter toutes les 1ms
        compteur++;             // valeur du compteur en multiple de 1ms
        
        if (compteur == 100)        //  2Hz
        {
            compteur = 0;
            Chenillard();
        }
  
/*  Lecture commande reue  */
        if(Data_Rdy_UART())     // Si une nouvelle commande a t reue
        {
            Read_Data_UART(command);    // transfert la commande
            printf("> %s\r\n",command);   // Echo
        }
    }
}