/* 
 * File:   system.h
 * Author: F.Giamarchi
 *
 * Created on 3 janvier 2017, 00:00
 */

#ifndef SYSTEM_H
#define	SYSTEM_H

/* Frquence de l'oscillateur */
#define _XTAL_FREQ 32000000 // Cette ligne permet d'utiliser les temporisations

// Ces lignes permettent de donner des noms explicites  des lignes du C et  des regsitres
//  TODO 1 -> Lignes en sorties
#define DEL LATBbits.LATB0
#define DIR_DEL TRISBbits.TRISB0

#define DEL_OFF DEL = 0
#define DEL_ON DEL = 1
#define DEL_CLI DEL = !DEL

#define DIR_TX TRISBbits.TRISB5

//  TODO 1 -> Lignes en entres
#define BP PORTBbits.RB1
#define DIR_BP TRISBbits.TRISB1

#define DIR_RX TRISBbits.TRISB2

// Din NeoPixel
#define DIR_DIN TRISAbits.TRISA0
#define DIN LATAbits.LATA0

/*  Dclaration de la fonction d'initialisation du microcontroleur */
void Init_System(void);

/*  Fonction temporisation en msec. */
void delayMs(uint16_t ms);

/* Dclaration des fonctions associes au Convertisseur Analog Digital */
//void Init_ADC (void);
//void SelChanADC (uint8_t canal);
//uint8_t ReadAdc8Bits (void);

/* Dclaration des fonctions de gestion du Timer0 */
void Init_Timer0(void);
void Synchronisation(void);
/*  Dclarations des macros pour le Timer0 */
#define TMR0_PRE 0b100          // Prescaleur sur 1/32
#define TMR0_VALUE 0xFF-249     // 250 * 32 * 125ns = 1ms

/*  Dclaration des fonctions associes  l'UART */
void Init_UART(void);
void putch(char c);
//char getch(void);

#endif	/* SYSTEM_H */

